/* ------------------------------------------------------------------   
	Program	: 08_36_Mascot.cpp
	Date	   : Apr 8, 2004
   Topic	   : Modifying Objects

  Description: given a univeristy name, this program returns the
  mascot for that school.
  

  Discuss:
   Selection structures
   String operations
   Whitespace characters
   getline()
 ------------------------------------------------------------------ */

#include <iostream>              
#include <string> 
using namespace std;                 


string Mascot(string university);


void main()
{
  string school;

  cout << "\nSchool names are capitalized: Iowa, Michigan, Ohio State, Penn State";
  cout << endl << endl;

  do
  { 
    school = "";
    cout << "\nEnter a Big 10 school (Q to quit): ";
    getline(cin, school,'\n');
    cin.ignore();

    if (school == "Q" || school == "q") break;    
    cout << Mascot(school) << endl << endl;

  } while ( school != "Q"   &&   school != "q");

}



string Mascot(string university)
/* Mascot returns the mascot for a Big 10 university.
 * 
 * Receive:      university, a string
 * Precondition: university is a Big 10 university
 * Return:       the (string) mascot of university
 ----------------------------------------------------------- */
{
   if (university == "Illinois")
      return "Fighting Illini";
   else if (university == "Indiana")
      return "Hoosiers";
   else if (university == "Iowa")
      return "Hawkeyes";
   else if (university == "Michigan")
      return "Wolverines";
   else if (university == "Michigan State")
      return "Spartans";
   else if (university == "Minnesota")
      return "Golden Gophers";
   else if (university == "Northwestern")
      return "Wildcats";
   else if (university == "Ohio State")
      return "Buckeyes";
   else if (university == "Penn State")
      return "Nittany Lions";
   else if (university == "Purdue")
      return "Boilermakers";
   else if (university == "Wisconsin")
      return "Badgers";
   else
   {
      cerr << "Mascot: " << university 
           << " is not known by this program!" << endl;
      return "";
   }
}
