/* ---------------------------------------------------------------------
 Program	: 09_01_RelnOpers.cpp   
 Topic	: Selection
 Date		: Apr 8, 2004
 
 Preprocessor directive #define creates a macro which is like a typing
 aid.  Essentially, when the macro appears, it is expanded (replaced by)
 the definition, including any arguments.

 The number-sign or stringizing operator (#) converts macro parameters 
 (after expansion) to string constants. It is used only with macros that
 take arguments. If it precedes a formal parameter in the macro definition,
 the actual argument passed by the macro invocation is enclosed in 
 quotation marks and treated as a string literal. The string literal then
 replaces each occurrence of a combination of the stringizing operator and
 formal parameter within the macro definition.

 ---------------------------------------------------------------------- */
#include <iostream>
#include <iomanip>
using namespace std;


#define P(EX)  cout << setw(6) << #EX << ": \t" << EX << endl << endl;


int main()
{
  int i,j;

  cout << "Enter two integers: ";
  cin >> i >> j;

  P( (i > j) );
  P( (i < j) );

  P( (i >= j ) );
  P( (i <= j ) );

  P( (i == j ) );
  P( (i != j ) );

  P( (i && j) );
  P( (i || j) );
  P( ( i < 10   && j < 10 ) );


  return 0;
} 

