/* ---------------------------------------------------------
 Program	   : 11_16_Scope.cpp   
 Topic		: Functions
 Date		   : Apr 8, 2004

 
 Name hiding: This program shows that when a local variable 
 has the same name as a global variable, the function only 
 "sees" the local variable.   That is, the scope of the
 global variable does include blocks in which its name is
 hidden by locally defined variables.

 The global variable by the same name can be 
 accessed within a block in which it is hidden using the
 scope resolution operator.

 --------------------------------------------------------- */
#include <iostream>
using namespace std;

void Texas(void); 
void Arkansas(void);

int Cows = 560;


void main(void)
{
	cout << "There are " << Cows << " cows in main.\n\n";
	Texas();
	Arkansas();
	cout << "Back in main, there are still " << Cows << " cows.\n";
}



void Texas(void)
{
	int Cows = 100;
	cout << "There are " << Cows << " cows in Texas.\n\n";
}



void Arkansas(void)
{
	int Cows = 50;

	cout << "There are " << Cows << " cows in Arkansas.\n";
    cout << "But using the :: operator, Arkansas is still "
         << "aware that there are\n " << ::Cows << " cows globally"
         << endl << endl;
}
