
/* ---------------------------------------------------------
 Program	   : 11_19_Static.cpp   
 Topic		: Functions
 Date		   : Apr 9, 2004
 
 This program shows that local variables do not retain 
 their values between function calls and that this
 behavior can be altered with the 'static' storage class
 specifier.

 It should also be noted that a static local variable is
 initialized only once.
 --------------------------------------------------------- */
#include <iostream>
using namespace std;

void ShowLocal();
void ShowStatic();


void main()
{
	ShowLocal();
	ShowLocal();

	for (int Count = 0; Count < 5; Count++)
		ShowStatic();

}



void ShowLocal(void)
{
	int LocalNum = 5;  

	cout << "LocalNum is " << LocalNum << endl;
	LocalNum = 99;
}




void ShowStatic(void)
{
	static int StatNum = 8;

	cout << "StatNum is " << StatNum << endl;
	StatNum++;
}
