/* ------------------------------------------------------------
    Program : 12_01_Array.cpp
    Date	   : Apr 12, 2004
    Topic	: Arrays

    Discuss	: array arguments, array parameters
  ------------------------------------------------------------ */
#include <iostream>
#include <iomanip>
using namespace std;

const int MAX = 50;


void FillArray(int A[], const int size);			
void DisplayArray(const int A[], const int size);		

void main()
{
 int array[MAX];

	 FillArray(array, MAX);
	 DisplayArray(array, MAX);
} 



// Note: A is already an address, so the & operator is not needed to implement
// reference parameter semantics.

void FillArray(int A[], const int size) 
{
	for (int i = 0; i < size; ++i)
		 A[i] = 2*i+3;

}


// By making A const, we protect it from being altered even though the address
// of A is passed as the argument.

void DisplayArray(const int A[], const int size)
{ int nPerLine = 10;
	cout << "\nThe array contains:" << endl;
	for (int i = 0; i < size; ++i)
	  {	cout << A[i] << ", ";
         if ( !((i+1) % nPerLine) )
           cout << endl;
      }
}

