
/* ---------------------------------------------------------
 Program	: 12_24_2DProcessing.cpp 
 Topic		: Structured Data Types
 
 Date		: May 24, 2000
 
 
 --------------------------------------------------------- */
#include <iostream>
#include <iomanip>
using namespace std;

const int students = 3;      // number of students
const int exams    = 4;      // number of exams

int minimum( int [][ exams ], int, int );
int maximum(int [][ exams ], int, int );
float average( int [], int );
void printArray( int [][ exams ], int, int );

int main()
{
   int studentGrades[ students ][ exams ] = 
          { { 77, 68, 86, 73 },
            { 96, 87, 89, 78 },
            { 70, 90, 86, 81 } };

   cout << "The array is:\n";
   printArray( studentGrades, students, exams );
   cout << "\n\nLowest grade: "
        << minimum( studentGrades, students, exams ) 
        << "\nHighest grade: "
        << maximum( studentGrades, students, exams ) << '\n';

   for ( int person = 0; person < students; person++ )
      cout << "The average grade for student " << person << " is " 
           << setiosflags( ios::fixed | ios::showpoint ) 
           << setprecision( 2 ) 
           << average( studentGrades[ person ], exams ) << endl;

   return 0;
}

// Find the minimum grade
int minimum( int grades[][ exams ], int pupils, int tests )
{
   int lowGrade = 100;

   for ( int i = 0; i < pupils; i++ )

      for ( int j = 0; j < tests; j++ )

         if ( grades[ i ][ j ] < lowGrade )
            lowGrade = grades[ i ][ j ];

   return lowGrade;
}

// Find the maximum grade
int maximum( int grades[][ exams ], int pupils, int tests )
{
   int highGrade = 0;

   for ( int i = 0; i < pupils; i++ )

      for ( int j = 0; j < tests; j++ )

         if ( grades[ i ][ j ] > highGrade )
            highGrade = grades[ i ][ j ];

   return highGrade;
}

// Determine the average grade for a particular student
float average( int setOfGrades[], int tests )
{
   int total = 0;

   for ( int i = 0; i < tests; i++ )
      total += setOfGrades[ i ];

   return ( float ) total / tests;
}

// Print the array
void printArray( int grades[][ exams ], int pupils, int tests ) 
{
   cout << "                 [0]  [1]  [2]  [3]";

   for ( int i = 0; i < pupils; i++ ) {
      cout << "\nstudentGrades[" << i << "] ";

      for ( int j = 0; j < tests; j++ )
         cout << setiosflags( ios::left ) << setw( 5 ) 
              << grades[ i ][ j ];
   }
}


