
/* ---------------------------------------------------------
 Program	   : 12_39_DynStruct.cpp   
 Topic		: Structured Data Types
 
 Date		   : Apr 12, 2004
 
 Topics:
  dynamic allocation of a struct
  pointer structure member
 --------------------------------------------------------- */
#include <iostream>
#include <iomanip>
#include <cstdlib>
using namespace std;



struct PayRoll
{
	int   EmpNumber;	// Employee number
	char  Name[25];		// Employee's name
	float Hours;		// Hours worked
	float PayRate;		// Hourly Payrate
	float GrossPay;	    // Gross Pay
};

void main()
{
	PayRoll *Employee;	
					
	Employee = new PayRoll;	
	if (Employee == NULL)	
	{
		cout << "Memory allocation error!\n";
		exit(EXIT_FAILURE);
	}

	cout << "Enter the employee's number: ";
	cin >> Employee->EmpNumber;

	cout << "Enter the employee's name: ";
	cin.ignore();	// To skip the remaining '\n' character
	cin.getline(Employee->Name, 25);

	cout << "How many hours did the employee work? ";
	cin >> Employee->Hours;
	cout << "What is the employee's hourly payrate? ";
	cin >> Employee->PayRate;

	Employee->GrossPay = Employee->Hours * Employee->PayRate;

	cout << "Here is the employee's payroll data:\n";
	cout << "Name: " << Employee->Name << endl;
	cout << "Number: " << Employee->EmpNumber << endl;
	cout << "Hours worked: " << Employee->Hours << endl;
	cout << "Hourly Payrate: " << Employee->PayRate << endl;
	cout.precision(2);
	cout << fixed << showpoint;
	cout << "Gross Pay: $" << Employee->GrossPay << endl;
	delete Employee;  // Free the allocated memory
}
