
/* ---------------------------------------------------------
 Program	   : 13_06_FileAppend.cpp   
 Topic		: File Operations
 
 Topic:
   1. ios openmode constants  ios::in, ios::out, ios::app
   2. using a stream for both input and output
   3. eof()
   4. assert()

 This program appends information to an existing file, closes
 it, then reopens it in read mode
 --------------------------------------------------------- */
#include <iostream>
#include <fstream>
#include <cassert>
using namespace std;


void main(void)
{
	ofstream ofil;
    ifstream ifil;
    char word[16];

		// Open file and place write marker at end of file
	ofil.open("wordfile.txt", ios::app);
    assert(ofil);

		// Append some words to the file, then close it
	ofil << "newlywed\n";
	ofil << "forgotten\n";
	ofil << "belltower\n";
	ofil.close();

		// Clear the fail bit
    ofil.clear();
		// Now, reestablish the connection and read the file
	ifil.open("wordfile.txt");
    assert(ifil);

	while (!ifil.eof() )
      { ifil >> word;
        cout << word << endl;
      }
 
	ifil.close();

}
