/* -------------------------------------------------------------- 
  Program	: 13_07_Meteorology.cpp 
  Date		: June 19, 2001

  Requires	: meteorology.dat

  Reads meteorological data stored in a file, 
  computes the minimum, maximum, and average of the readings, 
  and writes these statistics to an output file.
 
   Input(keyboard): names of the input and output files
   Input(file):     a sequence of meterological readings.
   Output(file):    the number of readings, the minimum reading,
                    the maximum reading, and the average reading.
  --------------------------------------------------------------  */
#include <iostream>                 
#include <fstream>                  
#include <string>                     
#include <cassert>                   
#include <cfloat>   
using namespace std;


int main()
{
   cout << "This program computes the number, maximum, minimum, and\n"
        << "average of an input list of numbers in one file,\n"
        << "and places its results in another file.\n\n";

   // ----------- Input Section -------------------------------------

   cout << "Enter the name of the input file: ";
   string inputFileName;
   cin >> inputFileName;              
                                             // open an input stream to 
   ifstream inStream;                        //  the input file,
   inStream.open(inputFileName.c_str());     //  establish connection,
   assert(inStream.is_open());               //  check for success

   int count = 0;                            // number of values
   double reading,                           // value being processed
          maximum = DBL_MIN,                 // largest seen so far
          minimum = DBL_MAX,                 // smallest seen so far
          sum = 0.0;                         // running total 

   for (;;)                                 
   {  inStream >> reading;                   
      if (inStream.eof()) break;             

      count++;                               
      sum += reading;                        
      if (reading < minimum)
         minimum = reading;                  
      if (reading > maximum)
         maximum = reading;                  
   }                                         

   inStream.close();                         

   // ------------ Output Section ----------------------------------

   cout << "Enter the name of the output file: ";
   string outputFileName;
   cin >> outputFileName;
                                             
   ofstream outStream(outputFileName.c_str());                                             
   assert(outStream.is_open());              
                                             
   outStream << "\n--> There were " << count << " values.";

   if (count > 0)
      outStream << "\n\tranging from " << minimum 
                << " to " << maximum
                << "\n\tand their average is " << sum / count 
                << endl;

   outStream.close();                        
   cout << "Processing complete.\n";
   return 0;
}

