
/* ---------------------------------------------------------
 Program	   : 13_16_Binary.cpp   
 Topic		: File Operations
 
 This program demonstrates the use of a structure variable to
 store a record of information to a binary file.

 See the program 13_17_RdBin.cpp after running this program.
 
 --------------------------------------------------------- */
#include <iostream>
#include <fstream>
#include <cctype> 
using namespace std;


struct Info
{
	char Name[51];
	int  Age;
	char Address1[51];
	char Address2[51];
	char Phone[14];
};


void main()
{
	ofstream People;
	Info person;
	char again;

   People.open("people.dat",  ios::binary | ios::app);
	if (People == 0)
	{
		cout << "Error opening file. Program aborting.\n";
		return;
	}
	do
	{
		cout << "Enter the following information about a "
		     << "person:\n";
		cout << "Name: ";
		cin.getline(person.Name, 51);
		cout << "Age: ";
		cin >> person.Age;
		cin.ignore(); // skip over remaining newline.
		cout << "Address line 1: ";
		cin.getline(person.Address1, 51);
		cout << "Address line 2: ";
		cin.getline(person.Address2, 51);
		cout << "Phone: ";
		cin.getline(person.Phone, 14);

		People.write((char *)&person, sizeof(person));

		cout << "Do you want to enter another record? ";
		cin >> again;
		cin.ignore();
	} while (toupper(again) == 'Y');
	People.close();
}
