
/* ---------------------------------------------------------
 Program	   : 14_09_SubPtr.cpp   
 Topic		: Pointers
 
 --------------------------------------------------------- */

#include <iostream>
using namespace std;

void copy1(char *, const char *);
void copy2(char *, const char *);



int main()
{
   int b[] = { 10, 20, 30, 40 };
   int *bPtr = b;   // set bPtr to point to array b

   cout << "Array b printed with:\n" 
        << "Array subscript notation\n";

   for ( int i = 0; i < 4; i++ )
      cout << "b[" << i << "] = " << b[ i ] << '\n';


   cout << "\nPointer/offset notation where\n"
        << "the pointer is the array name\n";

   for ( int offset = 0; offset < 4; offset++ )
      cout << "*(b + " << offset << ") = " 
           << *( b + offset ) << '\n';


   cout << "\nPointer subscript notation\n";

   for ( i = 0; i < 4; i++ )
      cout << "bPtr[" << i << "] = " << bPtr[ i ] << '\n';

   cout << "\nPointer/offset notation\n";

   for ( offset = 0; offset < 4; offset++ )
      cout << "*(bPtr + " << offset << ") = "
           << *( bPtr + offset ) << '\n';


   char str1[10], *str2 = "Hello", str3[10], str4[] = "Good Bye";
   copy1(str1, str2);
   copy2(str3, str4);
   cout << "\n str1 = " << str1 << endl;
   cout << "\n str3 = " << str3 << endl;

   return 0;
}




void copy1(char *s1, const char *s2)
{ 
   for( int i=0; ( s1[i] = s2[i] ) != '\0'; i++);
}



void copy2(char *s1, const char *s2)
{ 
   for( ; ( *s1 = *s2 ) != '\0'; s1++, s2++);
}



