/* ------------------------------------------------------------------
    
	Program	: 14_10_Calculator.cpp
	Date	   : Apr 13, 2004

  Description: this program implements a simple 8-function calculator.

  Topics to discuss:
    Selection structures
	Boolean variables
	Relational operators
	Logical operators
	if      if...else       if...else if    
	For loop syntax and semantics reviewed
	Functional Decomposition
 ------------------------------------------------------------------ */

#include <iostream>      	   
#include <string>                
#include <cassert>  
#include <cmath>  
using namespace std;         



int    Factorial(int n);
bool   GetOperator(char &op);
void   GetOperands(char op, double &oprnd1, double &oprnd2);
bool   isValidOperation(char);
double Result(char oprtr, double oprnd1, double oprnd2);



void main()
{  double operand1, operand2;
   char   theOperator;
   bool   done = false;

   cout << "\n\nWelcome to the 8-function calculator!\n\n";

   do
   {
    if ( GetOperator(theOperator) )
		{ GetOperands(theOperator, operand1, operand2);
		  cout << "The result is " 
			<<  Result(theOperator, operand1, operand2) << endl << endl;
		}		
      else
		done = true;

   } while ( ! done );
}





bool  GetOperator(char &op)
/* -----------------------------------------------------------------
  Prompt the user to enter an operator.
  Postcondtion:  op is assigned and is a valid operator
	Return: true if op is an arithmetic operation, false if equal to 'q'
   ----------------------------------------------------------------- */
{
  const string MENU = "Enter:\n"
                       "  + for the addition operation\n"
                       "  - for the subtraction operation\n"
                       "  * for the multiplication operation\n"
                       "  / for the division operation\n"
                       "  ^ for the exponentiation operation\n"
                       "  l for the base-10 logarithm operation\n"
                       "  ! for the (integer) factorial operation and\n"
                       "  q to quit.\n"
                       "--> ";
  do {
	cout << MENU;
	cin >> op;
	} while ( !isValidOperation(op) );

  return  ( op == 'q'  || op == 'Q' ) ? false : true;
	
}
  


bool isValidOperation(char op)
// Returns true if op is a valid operation or the signal to quit.
{  static char validOps[] = "+-*/^l!q";
   char *p = validOps;
   while ( *p )
      if ( op == *p++ ) 
		        return true;
   return false;
}



void GetOperands(char operation, double &opd1, double &opd2)
/* -----------------------------------------------------------------------
  Receive:       operation, a character     
  Prompt for one operand for unary operations, two operands for binary
   operations.           
  Precondition:  operation is one of +, -, *, /, ^, l, !
  Postcondition: operands are assigned                   
 ----------------------------------------------------------------------- */
{
      cout << "\nEnter the first operand: ";
      cin >> opd1;

      if (operation == '+' || operation == '-' ||
          operation == '*' || operation == '/' ||
          operation == '^')
	    {
           cout << "\nEnter the second operand: ";
           cin >> opd2;
        }
	  else
		opd2 = 1.0;
}

           

double Result(char theOperator, double operand1, double operand2)
/* -----------------------------------------------------------------------
  OperationResult applies theOperator to operand1 and operand2.
 
  Receive:      theOperator, a character
                operand1 and operand2, two doubles
  Precondition: theOperator is one of +, -, *, /, ^, l, !
  Return:       the result of applying theOperator to operand1 
                  and operand2
 ----------------------------------------------------------------------- */
{
   if (theOperator == '+')
      return operand1 + operand2;

   else if (theOperator == '-')
      return operand1 - operand2;

   else if (theOperator == '*')
      return operand1 * operand2;

   else if (theOperator == '/')
      if (operand2 != 0)
         return operand1 / operand2;
      else
        { cerr << "Operation Result: division by 0 -- result undefined!\n";
          return 0;
        }

   else if (theOperator == '^')
      return pow(operand1, (int)operand2);

   else if (theOperator == 'l')
      return log10(operand1);

   else if (theOperator == '!')
      return (double)Factorial((int)operand1);

   else
   {
      cerr << "OperationResult: invalid operator "
           << theOperator << " received!\n";
      return 0.0;
   }
}



int Factorial(int n)
{
   assert(n >= 0);
   int product = 1;

   for (int count = 2; count <= n; count++)
      product *= count;
   return product;
}
