
/* ---------------------------------------------------------
 Program	   : 14_23_DynAlloc.cpp   
 Topic		: Pointers
 
 This program totals and averages the sales figures for any
 number of days. The figures are stored in a dynamically
 allocated array.
 
 --------------------------------------------------------- */
#include <iostream>
#include <iomanip>
using namespace std;



void main()
{
	float *Sales, Total, Average;
	int i, NumDays;

	cout << "How many days of sales figures to process? :";
	cin >> NumDays;
	Sales = new float[NumDays];  
	if (Sales == NULL)  
	{	cout << "Error allocating memory!\n";
		return;
	}


	// Get the sales figures from the user
	cout << "Enter the sales figures below.\n";
	for (Total = 0., i = 0; i < NumDays; i++)
	{
		cout << "Day " << (i + 1) << ": ";
		cin >> Sales[i];
        Total += Sales[i];
	}


	// Calculate the average sales per day
	Average = Total / NumDays;

	// Display the results
	cout << fixed << showpoint << setprecision(2);

	cout << "\n\nTotal Sales: $" << Total << endl;
	cout << "Average Sales: $" << Average << endl;

	// Free dynamically allocated memory
	delete [] Sales;
}
