//  Program:  14_28_Sort.cpp
//  Selection-sorts a list of numbers entered at the keyboard.

#include <iostream>
#include <cstdlib>
using namespace std;



void fill_array(int a[], int size);

void sort(int a[], int size);

void swap_values(int& v1, int& v2);


int index_of_smallest(const int a[], int start_index, int number_used);



int main( )
{
    cout << "This program sorts numbers from lowest to highest.\n";

    int array_size;
    cout << "How many numbers will be sorted? ";
    cin >> array_size;

    int * a = new int[array_size];
    if (a == NULL)
    {
        cout << "Error: Insufficient memory.\n";
        exit(1);
    }

    fill_array(a, array_size);
    sort(a, array_size);

    cout << "In sorted order the numbers are:\n";
    for (int index = 0; index < array_size; index++)
        cout << a[index] << " ";
    cout << endl;

    delete [] a;

    return 0;
}



void fill_array(int a[], int size)
{
    cout << "Enter " << size << " integers.\n";
    for (int index = 0; index < size; index++)
        cin >> a[index];
}



void sort(int a[], int size)
{
   int index_of_next_smallest;
	 for (int index = 0; index < size - 1; index++)
    {//Place the correct value in a[index]:
        index_of_next_smallest =
                        index_of_smallest(a, index, size);
        swap_values(a[index], a[index_of_next_smallest]);
        //a[0] <= a[1] <=...<= a[index] are the smallest of the original array 
        //elements. The rest of the elements are in the remaining positions.
    }
}


void swap_values(int& v1, int& v2)
{
    int temp;
    temp = v1;
    v1 = v2;
    v2 = temp;
}


int index_of_smallest(const int a[], int start_index, int number_used)
{
    int min = a[start_index],
        index_of_min = start_index;
    for (int index = start_index + 1; index < number_used; index++)
        if (a[index] < min)
        {
            min = a[index];
            index_of_min = index;
            //min is the smallest of a[start_index] through a[index]
        }

    return index_of_min;
}


