/* ----------------------------------------------------------------
   Program		  : MultiSortV1.cpp
	 Date			    : Oct 23, 2001
	 Requires		  : SortUtilsV1.h be in working directory
	 Compile with	: SortUtilsV1.cpp
	 Version		  : 1.0

	 Description:  this program illustrates
		1- Multifile program organization
		2- Visual C++ projects
		3- Function pointers
   ---------------------------------------------------------------- */
#include <iostream>
#include <iomanip>
#include "SortUtilsV1.h"
using namespace std;



void main()
{
  const int MAX = 10;
  int       i;
  Order		  order;
  int		    a[MAX] = { 45, 2, 6, 4, 37, 8, 45, 10, 89, 12};

		// Display original array
  cout << "\n Original array: \n";
  for (i=0; i<MAX; ++i)
	cout << setw(4) << a[i];
  cout << endl;

		// Select the sort order and sort the array
  order = SelectOrder();
  if (order == ASCENDING)
	  BubbleSort(a, MAX, ascending);
  else
	  BubbleSort(a, MAX, descending);

		// Display the sorted array
  cout << "\n Sorted array: \n";
  for (i=0; i<MAX; ++i)
	cout << setw(4) << a[i];
  cout << endl;
}



