/* ----------------------------------------------------------------
   Program		  : MultiSortV2.cpp
	 Date			  : Mar 18, 2002
	 Requires	  : SortUtilsV2.h be in working directory
	 Compile with : SortUtilsV2.cpp
	 Version		  : 2.0 -- randomly generated values
						     -- array dynamically allocated
						


	 Description:  this program illustrates
		1- Multifile program organization
		2- Visual C++ projects
		3- Function pointers
   ---------------------------------------------------------------- */
#include <iostream>
#include <iomanip>
#include <cassert>
#include "SortUtilsV2.h"
using namespace std;



void main()
{
  int       size, max, nPerLine;
  Order		order;
  int *     a;


		// Select size of array and the maximum value
  cout << "\n Enter the size of the array to be sorted: ";
  cin >> size;
  cout << "\n Enter the max value to be generated: ";
  cin >> max;
  cout << "\n Enter the number of values to be displayed on a line: ";
  cin >> nPerLine;


		// Allocate an array of the requested size
  a = new int[size];
  assert(a);

		// Assign random values and display the original array
  FillArray(a, size, max);
  cout << "\n\nThe original array: \n";
  DisplayArray(a, size, nPerLine);

		// Select the sort order and sort the array
  order = SelectOrder();
  if (order == ASCENDING)
	      BubbleSort(a, size, ascending);
  else
	      BubbleSort(a, size, descending);

		// Display the sorted array
  cout << "\n\nThe sorted array: \n";
  DisplayArray(a, size, nPerLine);

    // Now use a selection sort
  FillArray(a, size, max);
  cout << "\n\nAnother array: \n";
  DisplayArray(a, size, nPerLine);

  SelectionSort(a, size);
  cout << "\n\nThe selection sorted array: \n";
  DisplayArray(a, size, nPerLine);

  delete [] a;
}



