/* ----------------------------------------------------------------
    File	:	SortUtilsV2.cpp
	 Date	:	Mar 18, 2002

	 Description: 
   ---------------------------------------------------------------- */
#include <iostream>
#include <iomanip>
#include "SortUtilsV2.h"
using namespace std;

void BubbleSort(int *w, const int size, bool (*inOrder)(int, int) )
{
  for (int pass=0; pass<size-1; ++pass)
  for (int i=size-1; i>pass; --i)
     if ( !(*inOrder)(w[i-1], w[i]) )
	    swap( &w[i-1], &w[i] );
}


void swap(int *x, int *y)
{ int temp;
   temp = *x;
   *x   = *y;
   *y   = temp;
}


bool ascending(int a, int b)
// Precondition: a, b are successive elements of
//  an integer array
{ return a < b;
}


bool descending(int a, int b)
// Precondition: a, b are successive elements of
//  an integer array
{ return a > b;
}


Order SelectOrder()
{ char ch, selection;  
	do
	{
		cout << "\n Enter A(scending) or D(escending) ";
		cout << "Your choice (A,D): ";
		cin >> ch;
		selection = toupper(ch);
	} while (selection != 'A'  && selection != 'D');

    if (selection == 'D')
		return DESCENDING;
	else
		return ASCENDING;
}


void SelectionSort(int *values, const int numValues)
/* -----------------------------------------------------------------
   ----------------------------------------------------------------- */
{
    int end = numValues-1;
    for (int current = 0; current < end; current++)
        swap(values[current], values[MinIndex(values, current, end)]);
}



int MinIndex(int *values, int start, int end)
/* -----------------------------------------------------------------
   Post: index of the smallest value in values[start]..values[end]
         is returned
   ----------------------------------------------------------------- */
{
    int indexOfMin = start;
    for (int index = start + 1; index <= end; index++)
        if (values[index] < values[indexOfMin])
            indexOfMin = index;
    return indexOfMin;
}



void FillArray(int *a, int n, int maxValue)
// Assign random values to the elements of array 'a'
// of size 'n'.  The values assigned will be in
// the range  [1, maxValue].
{
  for(int i=0; i<n; ++i)
    a[i] = rand() % maxValue +1;
}


void DisplayArray(int *a, int size, int nPerLine)
{ int width = 78/nPerLine;
  int line=0;
  char ch;

  cin.ignore();
  for (int i=0; i<size; ++i)
    {  cout << setw(width) << a[i];
       if ( (i+1) % nPerLine == 0)
          { cout << endl;
			if (++line % 20 == 0)
				{   cout << "\n Press <return> to continue";
					cin.get(ch);
					cout << endl;
				}
          }
    }
  cout << endl << endl;
}


