/* ------------------------------------------------------------  
    Program : 16_08_BinSearch.cpp
  
  ------------------------------------------------------------ */
#include <iostream>
#include <iomanip>
using namespace std;


const int MAX = 25;

 void FillArray(int A[MAX]);
 void Exchange(int &x, int &y);
 void InsertSort(int A[MAX]);
 int  BinSearch(int A[],int target,int first,int last);
 void DisplayArray(int A[MAX]);



void main()
{

	 int target, Array[MAX],index;


	 FillArray(Array);

	 cout << "\nRandom array before sorting" << endl;
	 DisplayArray(Array);

	 InsertSort(Array);
	 cout << "\n\nRandom array after sorting" << endl;
	 DisplayArray(Array);


	 cout << "\n\nWhat element do you want to search for? " << endl;
	 cin >> target;


	 index = BinSearch(Array, target, 0, MAX - 1);
	 if (index == -1)
		 cout << "The element " << target << " was not found in the array." << endl;
	 else
		 cout << "The element " << target << " was found at "
					 "index " << index << " of the array." << endl;
}




void FillArray(int A[MAX])
{
	 srand(1);      					
	 for (int i = 0; i < MAX; ++i) 		
		A[i] = rand()%100;         			
}




void Exchange(int &x, int &y)
{		
	int Temp = x;			
	x = y;					
	y = Temp;			
}





void InsertSort(int A[MAX])
{
	int j, i = 1;								
	while (i <= MAX-1)    				
	{
		 j = i;							
		 while ((j > 0) && (A[j] < A[j-1])) 
		 {
			Exchange(A[j], A[j-1]);
			--j;									
		 } 
		 ++i;	    								
												
	}  
}  




int BinSearch(int A[], int target, int first, int last)
// ------------------------------------------------------
//  Recursive version
//  Parameters:
//  A       : the array to search
//  target  : the item to search for
//  first   : the first index to search
//  last    : the last index 
//
//  Returns : the index of 'target' in array 'A'
//            -1 if 'target' is not found
// ------------------------------------------------------
{
	 int mid;						
	 if (first > last)    				
		 return (-1);       			
	 else
	 {
		 mid = (first + last) / 2;	
		 if (target == A[mid])    	
			 return (mid);           		
		 else                       			
			 if (target < A[mid])
					return (BinSearch(A, target, first, mid - 1));
			 else
					return (BinSearch(A, target, mid + 1, last));
					
	 }  
} 




void DisplayArray(int A[MAX])
{
	cout << "\nThe contents of the array are:" << endl;
	for (int i = 0; i < MAX; ++i)
			cout << ' ' << A[i];
}



/*
int BinSearch(int A[], int target, int first, int last)
// ------------------------------------------------------
//  Iterative version
// ------------------------------------------------------
{
	 int mid;		 

    while(last > first )
	 {
		 mid = (first + last) / 2;	
		 if (target == A[mid])    	
			 return mid;           		
		 else                       			
			 if (target < A[mid])
					last = mid - 1;
			 else
					first = mid + 1;
    }
    return -1;
} 
*/