
/* ---------------------------------------------------------
 Program	: BitOps.cpp  
 Date		: May 24, 2000
 
 --------------------------------------------------------- */
#include "printBinary.h"
#include <iostream>
using namespace std;

void printBinary(const unsigned char val);


// A macro to save typing:
#define PR(STR, EXPR) \
  cout << STR; printBinary(EXPR); cout << endl;  

void main()
{
  unsigned int getval;
  unsigned char a, b;

  cout << "Enter a number between 0 and 255: ";
  cin >> getval;
  a = getval;
 
  cout << "Enter a second number between 0 and 255: ";
  cin >> getval;
  b = getval;

  PR("a     = ", a);
  PR("b     = ", b);
  cout <<  endl;
 
  PR("a | b = ", a | b);
  PR("a & b = ", a & b);
  PR("a ^ b = ", a ^ b);
  PR("~a    = ", ~a);
  PR("~b    = ", ~b);


  // An interesting bit pattern:
  unsigned char c = 0x5A; 
  PR("c         = ", c);
  a |= c;
  PR("a |= c; a = ", a);
  b &= c;
  PR("b &= c; b = ", b);
  b ^= a;
  PR("b ^= a; b = ", b);
} 



void printBinary(const unsigned char val)
{
  for(int i = 7; i >= 0; i--)
    if(val & (1 << i))
      std::cout << "1";
    else
      std::cout << "0";
}

