// 20_41_Exception1.cpp
// A simple exception handling example.
// Checking for a divide-by-zero exception.
#include <iostream>
#include <stdexcept>
using namespace std;



double quotient( int numerator, int denominator)
{
   if ( denominator == 0 )
      throw exception("Div by zero");
   return static_cast< double > ( numerator ) / denominator;
}


int main()
{
   int number1, number2;
   double result;

   cout << "Enter two integers (end-of-file to end): ";

   while ( cin >> number1 >> number2 ) {
   
      // the try block wraps the code that may throw an 
      // exception and the code that should not execute
      // if an exception occurs
      try {   
         result = quotient( number1, number2 );
         cout << "The quotient is: " << result << endl;
      }
      catch ( exception & ex ) { // exception handler
         cout << "Exception occurred: " << ex.what() << '\n';
      }

      cout << "\nEnter two integers (end-of-file to end): ";
   }

   cout << endl;
   return 0;      // terminate normally
}


