/* 
 */
#include <iostream>    
#include <string>      
#include <cstdlib>     
#include <exception>   
using namespace std;

int main()
{
    try {
        // create two strings
         string firstname("bjarne");    // may trigger  bad_alloc
         string lastname("stroustrup"); // may trigger  bad_alloc
         string name;

        // manipulate strings
        firstname.at(20) = 'B';             // triggers  out_of_range
        lastname[30] = 'S';                 // ERROR: undefined behaviour

        // concatenate strings
        name = firstname + " " + lastname;  // may trigger  bad_alloc
    }
    catch (const  bad_alloc& e) {
        // special exception: no more memory
         cerr << "no more memory" <<  endl;
        return EXIT_FAILURE;    // exit main() with error status
    }
    catch (const  exception& e) {
        // other standard exceptions
         cerr << "standard exception: " << e.what() <<  endl;
        return EXIT_FAILURE;    // exit main() with error status
    }
    catch (...) {
        // all other exceptions
         cerr << "other unexpected exception" <<  endl;
        return EXIT_FAILURE;    // exit main() with error status
    }

     cout << "OK, everything was alright until now" <<  endl;
}
