/* 
 */
#include <iostream>    
#include <string>      
#include <cstdlib>     
#include <exception>   
using namespace std;

void processException( exception &e)
{
    try {
        throw e;    // rethrow the exception again so that it
                  // can be handled here
    }
    catch (const  out_of_range & e) {
        // special exception: no more memory
         cerr << "no more memory" <<  endl;
    }

    catch (const  bad_alloc& e) {
        // special exception: no more memory
         cerr << "no more memory" <<  endl;
    }
    catch (const  exception& e) {
        // other standard exception
         cerr << "standard exception: " << e.what() <<  endl;
    }
    catch (...) {
        // all other exceptions
         cerr << "other exception" <<  endl;
    }
}



int main()
{
    try {
        // create two strings
         string firstname("bjarne");    // may trigger  bad_alloc
         string lastname("stroustrup"); // may trigger  bad_alloc
         string name;

        // manipulate strings
        firstname.at(20) = 'B';             // triggers  out_of_range
        lastname[30] = 'S';                 // ERROR: undefined behaviour

        // chain strings
        name = firstname + " " + lastname;  // may trigger  bad_alloc
    }
    catch ( exception &e)
    {
        // deal with all exceptions in auxiliary function
        processException(e);
        return EXIT_FAILURE;    // exit main() with error status
    }

     cout << "OK, everything was alright up until now"
              <<  endl;

  return 0;
}
