
// 20_03_Stack.h

#ifndef TSTACK1_H
#define TSTACK1_H

#include <iostream.h>

template< typename T >
class Stack 
{
public:
   Stack( int = 10 );    
   ~Stack() { delete [] stackPtr; } 
   bool push( const T& ); 
   bool pop( T& );        
private:
   int size;             // # of elements in the stack
   int top;              // location of the top element
   T  *stackPtr;         // pointer to the stack

   bool isEmpty() const { return top == -1; }      // utility
   bool isFull()  const { return top == size - 1; } // functions
};




template< typename T >
Stack< T >::Stack( int s )
{
   size = s > 0 ? s : 10;  
   top = -1;               // Stack is initially empty
   stackPtr = new T[ size ]; // allocate space for elements
}



template< typename T >
bool Stack< T >::push( const T &pushValue )
{
   if ( !isFull() ) {
      stackPtr[ ++top ] = pushValue; // place item in Stack
      return true;  // push successful
   }
   return false;     // push unsuccessful
}




template< typename T > 
bool Stack< T >::pop( T &popValue )
{
   if ( !isEmpty() ) {
      popValue = stackPtr[ top-- ];  // remove item from Stack
      return true;  // pop successful
   }
   return false;     // pop unsuccessful
}

#endif